
#ifndef __algrafo__
#define __algrafo__ 1

typedef struct { int v; int w; } Edge;
Edge EDGE(int, int);

typedef struct Node *node;
struct Node {
  int num;
  node next;
};

node NovaLista();
node AddLista(node lista, int item);
int BuscaLista(node lista, int item);
node RemoveLista(node lista, int item);
void DestroiLista(node lista);
void ImprimeLista(node lista);


typedef struct Grafo *Graph;
struct Grafo {
  int E;
  int V;
  node* listas;
};

Graph GRAPHinit(int);
void GRAPHinsertE(Graph, Edge);
void GRAPHremoveE(Graph, Edge);
int GRAPHsearchE(Graph, Edge);
/*  int GRAPHedges(Edge [], Graph G); 		*/
/*  Graph GRAPHcopy(Graph); 			*/
void GRAPHdestroy(Graph);

void GRAPHshow(Graph);
Graph GRAPHrand(int, int);			

Graph GRAPHscan(int, int);
/*    Graph GRAPHscan_noST(int, int);		*/

/*    void GRAPHsearch(Graph);			*/
/*    void GRAPHshow_pre(Graph);		*/
int GRAPHconexo(Graph g);

#endif
